      SUBROUTINE EC12C(F,GR,GI,N1,N2,D1,D2,ALP,P,L,H,FR,FI)
         INTEGER L,N1,N2
         REAL ALP,D1,D2,FI,FR,GI,GR,H,P
         DIMENSION FI(N1,N2),FR(N1,N2),GI(N1,N2),GR(N1,N2),H(4)
         EXTERNAL FTFTC
         INTEGER I,J,N3,N4,N5,N6
         REAL B,DW1,DW2,Q,R,R1,R2,R3,R4,R5,R6,R7,R8,S1,S2,S3,SYS003,
     1        W1,W11,W2,W21
         COMPLEX Z,F
         DATA SYS003/6.283185/
       GO TO (10,20,20),L
   10  CONTINUE
       Q = 1.
       CALL FTFTC(GR,GI,N1,N2,Q)
       GO TO 110
   20  CONTINUE
       N3 = N1/2
       N4 = N2/2
       N5 = N1 + 1
       N6 = N2 + 1
       B = 1./(N1*N2)
       DW1 = SYS003/(N1*D1)
       DW2 = SYS003/(N2*D2)
       S1 = 0.
       S2 = 0.
       S3 = 0.
       DO 80 I = 1, N1
          IF (I .GT. N3) GO TO 30
             W1 = DW1*(I - 1)
             W11 = W1
             GO TO 40
   30     CONTINUE
          W1 = DW1*(N5 - I)
          W11 = -W1
   40     CONTINUE
          DO 70 J = 1, N2
             IF (J .GT. N4) GO TO 50
                W2 = DW2*(J - 1)
                W21 = W2
                GO TO 60
   50        CONTINUE
             W2 = DW2*(N6 - J)
             W21 = -W2
   60        CONTINUE
             Z = F(W11,W21)
             R1 = REAL(Z)
             R2 = AIMAG(Z)
             R3 = GR(I,J)
             R4 = GI(I,J)
             R5 = R1*R1 + R2*R2
             IF (W1 .EQ. 0. .AND. W2 .EQ. 0. .AND. P .EQ. 0.)
     1          W2 = 1.
             R = 1. + (W1*W1 + W2*W2)**P
             R6 = 1./(R5 + ALP*R)
             R7 = (R1*R3 + R2*R4)*R6
             R8 = (R1*R4 - R2*R3)*R6
             FR(I,J) = R7
             FI(I,J) = R8
             R3 = (R1*R7 - R2*R8) - R3
             R4 = (R1*R8 + R2*R7) - R4
             S1 = S1 + R3*R3 + R4*R4
             R3 = (R*B)*(R7*R7 + R8*R8)
             S2 = S2 + R3
             R4 = R*((ALP*R6)*R)*(ALP*R6)*R3
             S3 = S3 + R4
   70     CONTINUE
   80  CONTINUE
       H(1) = SQRT(S1*D1*D2*B)
       H(2) = SQRT(S2*D1*D2)
       H(3) = SQRT(H(1)*H(1) + ALP*H(2)*H(2))
       H(4) = SQRT(S3*D1*D2)
       IF (L .EQ. 3) GO TO 110
          Q = -1.
          CALL FTFTC(FR,FI,N1,N2,Q)
          DO 100 I = 1, N1
             DO 90 J = 1, N2
                FR(I,J) = FR(I,J)*B
                FI(I,J) = FI(I,J)*B
   90        CONTINUE
  100     CONTINUE
  110  RETURN
      END
